# Python imports

# Lib imports
import gi
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk

# Application imports



class ButtonControls(Gtk.ButtonBox):
    def __init__(self):
        super(ButtonControls, self).__init__()

        self._setup_styling()
        self._setup_signals()
        self._load_widgets()

        self.show_all()


    def _setup_styling(self):
        ...

    def _setup_signals(self):
        ...

    def _load_widgets(self):
        center_widget  = Gtk.ButtonBox()
        lrotate_button = Gtk.Button(label = "Rotate Left")
        vflip_button   = Gtk.Button(label = "Flip Vertical")
        one2one_button = Gtk.ToggleButton(label = "1:1")
        fit_button     = Gtk.ToggleButton(label = "Fit")
        hflip_button   = Gtk.Button(label = "Flip Horizontal")
        rrotate_button = Gtk.Button(label = "Rotate Right")

        center_widget.add(lrotate_button)
        center_widget.add(vflip_button)
        center_widget.add(one2one_button)
        center_widget.add(fit_button)
        center_widget.add(hflip_button)
        center_widget.add(rrotate_button)

        lrotate_button.set_image( Gtk.Image.new_from_icon_name("gtk-undelete", 4) )
        vflip_button.set_image( Gtk.Image.new_from_icon_name("gtk-orientation-reverse-portrait", 4) )
        one2one_button.set_image( Gtk.Image.new_from_icon_name("gtk-zoom-100", 4) )
        fit_button.set_image( Gtk.Image.new_from_icon_name("gtk-zoom-fit", 4) )
        hflip_button.set_image( Gtk.Image.new_from_icon_name("gtk-orientation-reverse-landscape", 4) )
        rrotate_button.set_image( Gtk.Image.new_from_icon_name("object-rotate-right", 4) )

        # TODO: add if check against settings pull to set 1:1 or fit
        one2one_button.set_active(True)

        lrotate_button.connect("clicked", self._rotate_left)
        vflip_button.connect("clicked", self._vertical_flip)
        one2one_button.connect("clicked", self._scale_1_two_1)
        fit_button.connect("clicked", self._fit_to_container)
        hflip_button.connect("clicked", self._horizontal_flip)
        rrotate_button.connect("clicked", self._rotate_right)

        self.set_center_widget(center_widget)

    def _rotate_left(self, widget = None, eve = None):
        event_system.emit("rotate_left")
    def _vertical_flip(self, widget = None, eve = None):
        event_system.emit("vertical_flip")
    def _scale_1_two_1(self, widget = None, eve = None):
        event_system.emit("scale_1_two_1")
    def _fit_to_container(self, widget = None, eve = None):
        event_system.emit("fit_to_container")
    def _horizontal_flip(self, widget = None, eve = None):
        event_system.emit("horizontal_flip")
    def _rotate_right(self, widget = None, eve = None):
        event_system.emit("rotate_right")
